;Quest'opera e' stata rilasciata sotto la licenza Creative Commons
;Attribuzione-Non commerciale-Condividi allo stesso modo 2.5 Italia.
;
;Per leggere una copia della licenza visita il sito web
;http://creativecommons.org/licenses/by-nc-sa/2.5/it/ o spedisci una
;lettera a Creative Commons, 171 Second Street, Suite 300,
;San Francisco, California, 94105, USA.
;
;
;This work is licensed under the Creative Commons
;Attribution-Noncommercial-Share Alike 2.5 Italy License.
;
;To view a copy of this license, visit
;http://creativecommons.org/licenses/by-nc-sa/2.5/it/ or send a letter
;to Creative Commons, 171 Second Street, Suite 300, San Francisco,
;California, 94105, USA.

; ________________________________________________
; |      Include per display driver LCD 877      |
; |______________________________________________|
; |   Include File                               |
; |______________________________________________|
; |   Tipo      : INC                            |
; |   Versione  : 1                              |
; |   Release   : 0                              |
; |   Autore    : Lain Walter                    |
; |   Data      : 02/11/09                       |
; |______________________________________________|

;INDIRIZZI DDRAM DISPLAY
;
;|00|01|02|03|04|05|06|07|08|09|0A|0B|0C|0D|0E|0F|
;|40|41|42|43|44|45|46|47|48|49|4A|4B|4C|4D|4E|4F|
;|10|11|12|13|14|15|16|17|18|19|1A|1B|1C|1D|1E|1F|
;|50|51|52|53|54|55|56|57|58|59|5A|5B|5C|5D|5E|5F|

;_______________________________________________________Costanti
;_______________Init
#define c_DISP_INIT1      0x30              ;primo byte init display
#define c_DISP_INIT2      0x38              ;secondo byte init display (8 bit, 2 righe, char 5x8)

;_______________Comandi sistema
#define c_DISP_CLRCMD     0x01              ;comando clear display
#define c_DISP_RETCMD     0x02              ;comando return home
#define c_DISP_MODCMD     0x06              ;comando set mode (incremento di 1, no shift)
#define c_DISP_ONCMD      0x0C              ;comando attivazione display (cursor+blink off)
;#define c_DISP_ONCMD      0x0E              ;comando attivazione display (cursor on, blink off)
;#define c_DISP_ONCMD      0x0F              ;comando attivazione display (cursor+blink on)
#define c_DISP_OFFCMD     0x08              ;comando disattivazione display

;_______________Sub
#define c_ROW1_ADDR       0x00              ;indirizzo inizio riga1 display
#define c_ROW2_ADDR       0x40              ;indirizzo inizio riga2 display
#define c_ROW3_ADDR       0x10              ;indirizzo inizio riga3 display
#define c_ROW4_ADDR       0x50              ;indirizzo inizio riga4 display

;_______________________________________________________Variabili

;_______________________________________________________FLAGS

;_______________Definizione caratteri LCD (standard HD44780)
#define c_CHAR_LCD_SPC    0x20              ;' '
#define c_CHAR_LCD_EXCL   0x21              ;!
#define c_CHAR_LCD_QUOT   0x22              ;"
#define c_CHAR_LCD_SHRP   0x23              ;#
#define c_CHAR_LCD_PERC   0x25              ;%
#define c_CHAR_LCD_AMPR   0x26              ;&
#define c_CHAR_LCD_APIC   0x27              ;'
#define c_CHAR_LCD_PARA   0x28              ;(
#define c_CHAR_LCD_PARC   0x29              ;)
#define c_CHAR_LCD_ASTR   0x2A              ;*
#define c_CHAR_LCD_PLUS   0x2B              ;+
#define c_CHAR_LCD_CMMA   0x2C              ;,
#define c_CHAR_LCD_MINU   0x2D              ;-
#define c_CHAR_LCD_DOT    0x2E              ;.
#define c_CHAR_LCD_SLSH   0x2F              ;/
#define c_CHAR_LCD_COLN   0x3A              ;:
#define c_CHAR_LCD_SMCL   0x3B              ;;
#define c_CHAR_LCD_MINR   0x3C              ;<
#define c_CHAR_LCD_EQUL   0x3D              ;=
#define c_CHAR_LCD_MAGR   0x3E              ;>
#define c_CHAR_LCD_QSTM   0x3F              ;?
#define c_CHAR_LCD_QDRA   0x5B              ;[
#define c_CHAR_LCD_QDRC   0x5D              ;]
#define c_CHAR_LCD_UNDR   0x5F              ;_
#define c_CHAR_LCD_GRFA   0x7B              ;{
#define c_CHAR_LCD_PIPE   0x7C              ;|
#define c_CHAR_LCD_GRFC   0x7D              ;}
#define c_CHAR_LCD_ARRR   0x7E              ;freccia a destra
#define c_CHAR_LCD_ARRL   0x7F              ;freccia a sinistra
#define c_CHAR_LCD_BLCK   0xFF              ;rettangolo nero

#define c_CHAR_LCD_0      0x30
#define c_CHAR_LCD_1      0x31
#define c_CHAR_LCD_2      0x32
#define c_CHAR_LCD_3      0x33
#define c_CHAR_LCD_4      0x34
#define c_CHAR_LCD_5      0x35
#define c_CHAR_LCD_6      0x36
#define c_CHAR_LCD_7      0x37
#define c_CHAR_LCD_8      0x38
#define c_CHAR_LCD_9      0x39

#define c_CHAR_LCD_A      0x41
#define c_CHAR_LCD_B      0x42
#define c_CHAR_LCD_C      0x43
#define c_CHAR_LCD_D      0x44
#define c_CHAR_LCD_E      0x45
#define c_CHAR_LCD_F      0x46
#define c_CHAR_LCD_G      0x47
#define c_CHAR_LCD_H      0x48
#define c_CHAR_LCD_I      0x49
#define c_CHAR_LCD_J      0x4A
#define c_CHAR_LCD_K      0x4B
#define c_CHAR_LCD_L      0x4C
#define c_CHAR_LCD_M      0x4D
#define c_CHAR_LCD_N      0x4E
#define c_CHAR_LCD_O      0x4F
#define c_CHAR_LCD_P      0x50
#define c_CHAR_LCD_Q      0x51
#define c_CHAR_LCD_R      0x52
#define c_CHAR_LCD_S      0x53
#define c_CHAR_LCD_T      0x54
#define c_CHAR_LCD_U      0x55
#define c_CHAR_LCD_V      0x56
#define c_CHAR_LCD_W      0x57
#define c_CHAR_LCD_X      0x58
#define c_CHAR_LCD_Y      0x59
#define c_CHAR_LCD_Z      0x5A

#define c_CHAR_LCD_a      0x61
#define c_CHAR_LCD_b      0x62
#define c_CHAR_LCD_c      0x63
#define c_CHAR_LCD_d      0x64
#define c_CHAR_LCD_e      0x65
#define c_CHAR_LCD_f      0x66
#define c_CHAR_LCD_g      0x67
#define c_CHAR_LCD_h      0x68
#define c_CHAR_LCD_i      0x69
#define c_CHAR_LCD_j      0x6A
#define c_CHAR_LCD_k      0x6B
#define c_CHAR_LCD_l      0x6C
#define c_CHAR_LCD_m      0x6D
#define c_CHAR_LCD_n      0x6E
#define c_CHAR_LCD_o      0x6F
#define c_CHAR_LCD_p      0x70
#define c_CHAR_LCD_q      0x71
#define c_CHAR_LCD_r      0x72
#define c_CHAR_LCD_s      0x73
#define c_CHAR_LCD_t      0x74
#define c_CHAR_LCD_u      0x75
#define c_CHAR_LCD_v      0x76
#define c_CHAR_LCD_w      0x77
#define c_CHAR_LCD_x      0x78
#define c_CHAR_LCD_y      0x79
#define c_CHAR_LCD_z      0x7A
